/* commands.h - IRC protocol tokens
 * Copyright 2000 srvx Development Team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: commands.h,v 1.10 2002/05/06 23:33:13 entrope Exp $
 */

#ifndef _commands_h
#define _commands_h
/*
 * Command defines -- compliant for P10
 */

#define CMD_ADMIN		"ADMIN"
#define CMD_AWAY		"AWAY"
#define CMD_BURST 		"BURST"
#define CMD_CLOSE		"CLOSE"
#define CMD_CNOTICE		"CNOTICE"
#define CMD_CONNECT		"CONNECT"
#define CMD_CPRIVMSG		"CPRIVMSG"
#define CMD_CREATE		"CREATE"
#define CMD_DESTRUCT		"DESTRUCT"
#define CMD_DESYNCH		"DESYNCH"
#define CMD_DIE			"DIE"
#define CMD_DNS			"DNS"
#define CMD_EOB			"END_OF_BURST"
#define CMD_EOB_ACK		"EOB_ACK"
#define CMD_ERROR		"ERROR"
#define CMD_GLINE		"GLINE"
#define CMD_HASH		"HASH"
#define CMD_HELP		"HELP"
#define CMD_INFO		"INFO"
#define CMD_INVITE		"INVITE"
#define CMD_ISON		"ISON"
#define CMD_JOIN		"JOIN"
#define CMD_JUPE		"JUPE"
#define CMD_KICK		"KICK"
#define CMD_KILL		"KILL"
#define CMD_LINKS		"LINKS"
#define CMD_LIST		"LIST"
#define CMD_LUSERS		"LUSERS"
#define CMD_MAP			"MAP"
#define CMD_MODE 		"MODE"
#define CMD_MOTD		"MOTD"
#define CMD_NAMES		"NAMES"
#define CMD_NICK 		"NICK"
#define CMD_NOTICE		"NOTICE"
#define CMD_OPER		"OPER"
#define CMD_PART		"PART"
#define CMD_PASS		"PASS"
#define CMD_PING		"PING"
#define CMD_PONG		"PONG"
#define CMD_PRIVMSG 		"PRIVMSG"
#define CMD_QUIT		"QUIT"
#define CMD_REHASH		"REHASH"
#define CMD_RESTART		"RESTART"
#define CMD_RPING		"RPING"
#define CMD_RPONG		"RPONG"
#define CMD_SERVER		"SERVER"
#define CMD_SERVLIST		"SERVLIST"
#define CMD_SERVSET 		"SERVSET"
#define CMD_SETTIME		"SETTIME"
#define CMD_SILENCE		"SILENCE"
#define CMD_SQUERY		"SQUERY"
#define CMD_SQUIT		"SQUIT"
#define CMD_STATS		"STATS"
#define CMD_TIME		"TIME"
#define CMD_TOPIC		"TOPIC"
#define CMD_TRACE		"TRACE"
#define CMD_UPING		"UPING"
#define CMD_USER		"USER"
#define CMD_USERHOST		"USERHOST"
#define CMD_USERIP		"USERIP"
#define CMD_VERSION		"VERSION"
#define CMD_WALLCHOPS		"WALLCHOPS"
#define CMD_WALLOPS		"WALLOPS"
#define CMD_WHO			"WHO"
#define CMD_WHOIS		"WHOIS"
#define CMD_WHOWAS		"WHOWAS"

/* Commands used in the CTCP protocol (http://www.invlogic.com/irc/ctcp.html) */
#define CMD_CTCP_ACTION		"ACTION"
#define CMD_CTCP_VERSION	"VERSION"
#define CMD_CTCP_PING		"PING"
#define CMD_CTCP_PONG		"PONG"
#define CMD_CTCP_CLIENTINFO	"CLIENTINFO"
#define CMD_CTCP_USERINFO	"USERINFO"
#define CMD_CTCP_TIME		"TIME"
#define CMD_CTCP_ERRMSG		"ERRMSG"

#define TOK_ADMIN		"AD"
#define TOK_AWAY		"A"
#define TOK_BURST 		"B"
#define TOK_CLOSE		"CLOSE"
#define TOK_CNOTICE		"CN"
#define TOK_CONNECT		"CO"
#define TOK_CPRIVMSG		"CP"
#define TOK_CREATE		"C"
#define TOK_DESTRUCT		"DE"
#define TOK_DESYNCH		"DS"
#define TOK_DIE			"DIE"
#define TOK_DNS			"DNS"
#define TOK_EOB			"EB"
#define TOK_EOB_ACK		"EA"
#define TOK_ERROR		"Y"
#define TOK_GLINE		"GL"
#define TOK_HASH		"HASH"
#define TOK_HELP		"HELP"
#define TOK_INFO		"F"
#define TOK_INVITE		"I"
#define TOK_ISON		"ISON"
#define TOK_JOIN		"J"
#define TOK_JUPE		"JU"
#define TOK_KICK		"K"
#define TOK_KILL		"D"
#define TOK_LINKS		"LI"
#define TOK_LIST		"LIST"
#define TOK_LUSERS		"LU"
#define TOK_MAP			"MAP"
#define TOK_MODE 		"M"
#define TOK_MOTD		"MO"
#define TOK_NAMES		"E"
#define TOK_NICK 		"N"
#define TOK_NOTICE		"O"
#define TOK_OPER		"OPER"
#define TOK_PART		"L"
#define TOK_PASS		"PASS"
#define TOK_PING		"G"
#define TOK_PONG		"Z"
#define TOK_PRIVMSG 		"P"
#define TOK_QUIT		"Q"
#define TOK_REHASH		"REHASH"
#define TOK_RESTART		"RESTART"
#define TOK_RPING		"RI"
#define TOK_RPONG		"RO"
#define TOK_SERVER		"S"
#define TOK_SERVLIST		"SERVLIST"
#define TOK_SERVSET 		"SERVSET"
#define TOK_SETTIME		"SE"
#define TOK_SILENCE		"U"
#define TOK_SQUERY		"SQUERY"
#define TOK_SQUIT		"SQ"
#define TOK_STATS		"R"
#define TOK_TIME		"TI"
#define TOK_TOPIC		"T"
#define TOK_TRACE		"TR"
#define TOK_UPING		"UPING"
#define TOK_USER		"USER"
#define TOK_USERHOST		"USERHOST"
#define TOK_USERIP		"USERIP"
#define TOK_VERSION		"V"
#define TOK_WALLCHOPS		"WC"
#define TOK_WALLOPS		"WA"
#define TOK_WHO			"H"
#define TOK_WHOIS		"W"
#define TOK_WHOWAS		"X"

/* RFC1459-compliant numeric responses */
#define RPL_ENDOFSTATS          219
#define RPL_STATSUPTIME         242
#define RPL_MAXCONNECTIONS      250
#define RPL_WHOISUSER           311
#define RPL_WHOISSERVER         312
#define RPL_WHOISOPERATOR       313
#define RPL_ENDOFWHOIS          318
#define ERR_NOSUCHNICK          401

#endif
