#include "config.h"
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#include "common.h"
#include "dict.h"
#include "log.h"
#include "recdb.h"

/* arghhhh */
time_t now;
int silent = 1;
void reg_exit_func(exit_func_t handler) {
    (void)handler;
}
int match_ircglob(const char *text, const char *glob) {
    (void)text; (void)glob;
    return 0;
}
int send_message(struct userNode *dest, struct userNode *src, const char *message, ...) {
    (void)dest; (void)src; (void)message;
    return 0;
}

/* Back to our regularly scheduled programming.. */

struct string_list *new_argv;

struct cfg_scan {
    struct cfg_scan *parent;
    char *path;
};

int
scan_db(const char *key, void *data, void *extra)
{
    struct record_data *rd = data;
    struct cfg_scan child, *self = extra;

    child.parent = extra;

    switch (rd->type) {
    case RECDB_QSTRING:
        if ((strcasestr(key, "enable")
             || (strcasestr(key, "disable"))
             || (strcasestr(key, "require")))
            && enabled_string(rd->d.qstring)) {
            char *new_arg;
            new_arg = malloc(strlen(self->path)+strlen(key)+4);
            sprintf(new_arg, "-D%s/%s", self->path, key);
            string_list_append(new_argv, new_arg);
        }
        break;
    case RECDB_OBJECT:
        child.path = malloc(strlen(self->path) + strlen(key) + 2);
        sprintf(child.path, "%s/%s", self->path, key);
        dict_foreach(rd->d.object, scan_db, &child);
        free(child.path);
        break;
    default: /* ignore */ break;
    }
    return 0;
}

int
main(int argc, char *argv[])
{
    const char *cfg_file;
    struct cfg_scan scanner;
    dict_t cfg_db;

    init_logs();
    time(&now);
    new_argv = alloc_string_list(4);
    string_list_append(new_argv, strdup("m4"));

    if (argc > 1) {
        cfg_file = argv[1];
    } else {
        cfg_file = "srvx.conf";
    }

    if (!(cfg_db = parse_database(cfg_file))) {
        fprintf(stderr, "Unable to parse config file %s; you will get a 'default' expansion.\n", cfg_file);
    } else {
        scanner.parent = NULL;
        scanner.path = "";
        dict_foreach(cfg_db, scan_db, &scanner);
    }

    string_list_append(new_argv, NULL);
    execvp("m4", new_argv->list);
    fprintf(stderr, "Error in exec: %s (%d)\n", strerror(errno), errno);
    return 1;
}
